{  X-Mailer

   OPEN SOURCE

   Programmiert von Bernd Dietzel (c)2003-2005  www.x-mailer.info  www.barret.de

   Programmiersprache Borland Delphi 7

   Bentigte Komponente : Indy 9   www.indyproject.org
}

unit Unitpostaus;  { ****** Postausgangsfenster ****** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, FileCtrl, Buttons, jpeg;

type
  TXAusgang = class(TForm)
    Panel1: TPanel;
    Buttonabbrechen: TBitBtn;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    LabelSMTP: TLabel;
    ButtonSenden: TBitBtn;
    LabelRemailer: TLabel;
    GroupBox1: TGroupBox;
    MemoGesendet: TMemo;
    PanelXmailerStatus: TPanel;
    Image1: TImage;
    Status: TPanel;
    GroupBoxsponor: TGroupBox;
    ImageSponsor: TImage;
    Labelsponsorlink: TLabel;
    Image2: TImage;
    LabelKontakt: TLabel;
    Image4: TImage;
    Image3: TImage;
    Image5: TImage;
    procedure ButtonSendenClick(Sender: TObject);
    procedure ButtonabbrechenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ImageSponsorClick(Sender: TObject);
    procedure LabelKontaktClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function TXT(TXTNr:integer):String;  {##Textstrings##}
    function Angebot(WerbeplatzNr:integer):boolean;
  end;

var
  TXTs: TStringlist; {##extracted text vom Source##}
  XAusgang: TXAusgang;

implementation

uses XMAIL61, Main, relay3,gnugettext;

{$R *.dfm}
 
{#### TEXT-STRINGS FROM SOURCE (c) 2004 by Bernd Dietzel  www.barret.de/textfromsource.zip ####} 
function TXAusgang.TXT(TXTNr:integer):String;
begin
 if not Assigned(TXTs) then
 begin
  TXTs:=Tstringlist.create;
  with TXTs do begin
         {------- text list  -- Only Translate Intems with the {T}
{0}   {T}Add(_('Bitte warten bis Senden beendet... Fenster nicht schliessen!')+' ');
{1}      Add('nostatus');
{2}   {T}Add(form1.TXT(4));   // intern AUS
{3}   {T}Add(form1.TXT(351)); // intern ##ABBRUCH##
{4}   {T}Add(_('Senden aktiv : warte auf Sendebesttigung'));
{5}   {T}Add(robot.TXT(9));  // SEARCH-ROBOT  ** beendet **   // -> siehe unit relay3
{6}   {T}Add(_('GESENDET'));
{7}   {T}Add(_('Senden beendet'));
{8}   {T}Add(_('Mit "Beenden" dieses Fenster schliessen'));
{9}   {T}Add(form1.TXT(502));  //  Ausgang
{10}     Add(': (');
{11}  {T}Add(form1.TXT(135));  // Status: bereit.
{12}  {T}Add(_('Unverbindliches Angebot'));
{13}  {T}Add(_('fr Werbeplatz #'));
{14}  {T}Add(_(' in X-Mailer'));
{15}  {T}Add(_('unterbreiten ?'));
{16}     Add('barret@barret.de');
{17}  {T}Add(_('Werbung in X-Mailer'));
{18}  {T}Add(_('Ich biete Ihnen ....... EUR'));
{19}  {T}Add(_('fr einen Monat, beginnend ab .......'));
{20}  {T}Add(_('Meine Wnsche und Anmerkungen :'));
{21}     Add('..........');
  end;
 end;
 Result := TXTs[TXTNr];
end;
{xx}


procedure TXAusgang.FormCreate(Sender: TObject);
begin
   TranslateComponent (self);  {  gnugettext }
end;

procedure TXAusgang.ButtonSendenClick(Sender: TObject);
{ wird auch von Posteingang - Automatisch weiterleiten - benutzt }
var
 Temp,MailName: widestring;
 i:integer;
 Loesch : array[0..5000] of boolean;   { Merker zum Loeschen der gesendeten Mails }
 Pfad   : array[0..5000] of widestring;
 KEEP,POST,SIMU:boolean;
begin
 GETMAILForm.DisconnectExecute(self); { Posteingang ausloggen sonst 'already connected' Fehler }
 KEEP:=GETMAILFORM.timerKEEP.Enabled;
 POST:=GETMAILForm.timerPost.Enabled;
 SIMU:=form1.timersimulier.Enabled; { Header-Editor Simulation darf Senden nicht stren }

 GETMAILFORM.timerKEEP.Enabled:=false;
 GETMAILForm.timerPost.Enabled:=false;
 form1.timersimulier.Enabled:=false;
 form1.TimerStatus.Enabled:=false;
 Statusbar1.Panels[0].text:=TXT(0) {##Bitte warten bis Senden beendet... Fenster nicht schliessen! ##} ;

 for i:=0 to 5000 do begin Loesch[i]:=false; Pfad[i]:=''; end;

 Temp:= form1.EMAILSPEICHERN(XmailerEntwurf,TXT(1) {##nostatus##} ,TXT(2) {##AUS##} ); { aktuelle Mail sichern }
 wiederherstellenPfad:=Temp;
 form1.buttonwiederherstellen.Visible:=true;  { bei abnormalem Abbruch Mail wiederherstellen mglich }

 { ***Alle zu sendenden Mails nacheinander in Hauptfenster laden und senden ****}
 if form1.Filelistboxausgang.Items.Count>0 then
 for i:=0 to form1.Filelistboxausgang.Items.Count-1 do
 begin
  if status.caption<>TXT(3) {##Abbruch##}  then
  begin
   MailName:=IncludeTrailingPathDelimiter(XMAILERAusgang)+form1.FileListBoxAusgang.Items[i];
   Pfad[i]:=MailName;
   Form1.EMAILLADEN(MailName); { Mail laden in Form1 }
   application.ProcessMessages;
   form1.Update;
   form1.MAILLISTEausgang.items[i].Selected:=true;
   status.caption:=TXT(4) {##Senden aktiv : warte auf Sendebesttigung##} ;
   form1.Status.Caption:=status.caption;
   form1.goClick(XAusgang); { *********** senden ******** }
   form1.MAILLISTEausgang.items[i].Selected:=false;

   { ---- Postausgang mit Robot, ohne eigenen Mailserver ---- }
   if labelsmtp.visible=true then
   begin
    while Robot.caption<>TXT(5) {##SEARCH-ROBOT  ** beendet **##}  do
    begin
     application.ProcessMessages;
     if status.caption=TXT(3) {##Abbruch##}  then
     begin
      Robot.close;
      Robot.caption:=TXT(5) {##SEARCH-ROBOT  ** beendet **##} ; { while-schleife abbrechen }
     end;
    end; { while pos }
    Robot.close;
   end;

  { ---- Postausgang ohne Robot (normal) ---- }
   if labelsmtp.visible=false then
   begin
    while pos(TXT(6) {##GESENDET##} ,uppercase(form1.Status.caption))=0 do  {warten bis /xmails/gesendet/ im Status Hauptfenster  }
    begin
     application.ProcessMessages;
     if status.caption=TXT(3) {##Abbruch##}  then form1.Status.Caption:=TXT(6) {##GESENDET##} ; { while-schleife abbrechen }
    end;
   end;

   if status.caption=TXT(3) {##Abbruch##}  then Form1.Status.Caption:=TXT(3) {##Abbruch##} 
     else Loesch[i]:=true;

  end; { wenn kein abbruch }

 end; { For i }

 { Gesendete Mails aus der Ausgangs-Liste raus }
 if Form1.FileListBoxAusgang.Items.Count>0 then
 for i:=0 to Form1.FileListBoxAusgang.Items.Count-1 do
 begin
  if loesch[i]=true then form1.loesche(Pfad[i]);
 end;

 XAusgang.Update;

 form1.EMAILLADEN(Temp);  { aktuelle Mail in Form1 zurckladen }
 form1.loesche(Temp);
 form1.buttonwiederherstellen.Visible:=false;
 if status.caption=TXT(3) {##Abbruch##}  then close;
 status.caption:=TXT(7) {##Senden beendet##} ;
 form1.Status.Caption:='';
 Statusbar1.Panels[0].text:=TXT(8) {##Mit "Beenden" dieses Fenster schliessen##} ;
{ Anzahl Mails anzeigen }
 form1.FileListBoxAusgang.Update;
 application.ProcessMessages;
 if form1.Filelistboxausgang.Items.count>0 then
  form1.pagecontrolverwalten.Pages[0].Caption:=TXT(9) {##Ausgang##} +TXT(10) {##: (##} +inttostr(form1.filelistboxausgang.Items.count)+')'
  else
  form1.pagecontrolverwalten.Pages[0].Caption:=TXT(9) {##Ausgang##} ;
 form1.pagecontrolverwalten.pages[0].Update;
 Form1.PageControlVerwaltenChange(self); { Filelistboxen in Form1 aktualisieren }


 GETMAILFORM.timerKEEP.Enabled:=KEEP;  { Timer Posteingang wieder an }
 GETMAILForm.timerPost.Enabled:=POST;
 form1.timersimulier  .Enabled:=SIMU;  { Header Simulation wieder an }
 form1.TimerStatus.Enabled:=true;

 xausgang.Close;
end;

procedure TXAusgang.ButtonabbrechenClick(Sender: TObject);
begin
 form1.Status.caption:=TXT(3) {##Abbruch##} ;
 status.caption:=TXT(3) {##Abbruch##} ;
 xausgang.close;
end;

procedure TXAusgang.FormShow(Sender: TObject);
{ wird auch von Posteingang - Automatisch weiterleiten - benutzt }
begin
  form1.TimerStatus.Enabled:=false;
  form1.PageControlVerwalten.ActivePageIndex:=0;
  status.caption      :=TXT(11) {##Status: bereit##} ; { <> ABBRUCH }
  form1.status.caption:=TXT(11) {##Status: bereit##} ; { <> ABBRUCH }
  MemoGesendet.Clear;
end;


procedure TXAusgang.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 form1.TimerStatus.Enabled:=true;
 Form1.PageControlVerwaltenChange(self); { Filelistboxen aktualisieren }
end;


procedure TXAusgang.ImageSponsorClick(Sender: TObject);
begin
 form1.BrowseURLbuissiness.Execute;
end;

function TXAusgang.Angebot(WerbeplatzNr:integer):boolean;
var
 nr:integer;
 code:DWORD;
 KN:TTreeNode;
begin
 result:=false;
 code:=MessageDlg( TXT(12) {##Unverbindliches Angebot##} +#13+#10+#13+#10
                  +TXT(13) {##fr Werbeplatz ###}
                  +inttostr(WerbeplatzNr)
                  +TXT(14) {## in X-Mailer##}
                  +#13+#10+#13+#10
                  +TXT(15) {##unterbreiten ?##}
                  ,  mtConfirmation,[mbNo, mbYes ] , 0);
 case code of
   mrno  : exit;
 end;

  { Mail schreiben aufklapen }
 KN:=form1.treeview1.items[TreeX[40]];
 if form1.Zeige(form1.Knoten(form1.TreeView1.items[TreeX[40]].Text {Mail schreiben} ,KN))=true then form1.KnotenExpandieren(KN);
 KN.Selected:=true;

 form1.mailto.text:=TXT(16) {##barret@barret.de##} ;
 form1.betreff.Text:=TXT(17) {##Werbung in X-Mailer##} ;
 form1.emailtext.Clear;
 form1.emailtext.Lines.Add(TXT(18) {##Ich biete Ihnen ....... EUR##} );
 form1.emailtext.Lines.Add(TXT(13) {##fr Werbeplatz ###}
                          +inttostr(WerbeplatzNr)
                          +TXT(14) {## in X-Mailer##} );
 form1.emailtext.Lines.Add(TXT(19) {##fr einen Monat, beginnend ab .......##} );
 form1.emailtext.Lines.Add(TXT(20) {##Meine Wnsche und Anmerkungen :##} );
 form1.emailtext.Lines.Add(TXT(21) {##..........##} );
 result:=true;
end;


procedure TXAusgang.LabelKontaktClick(Sender: TObject);
begin
 XAusgang.Show;
 XAusgang.Top:=1;
 if Angebot(2)=false then exit;
 XAusgang.Close;
end;

end.
