{  X-Mailer

   OPEN SOURCE

   Programmiert von Bernd Dietzel (c)2003-2005  www.x-mailer.info  www.barret.de

   Programmiersprache Borland Delphi 7

   Bentigte Komponente : Indy 9   www.indyproject.org
}


unit scanner3; { E-Mail Adressen in Dateien auf der Festplatte suchen }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, FileCtrl, ExtCtrls, jpeg, ComCtrls, ToolWin;

type
  TESCAN = class(TForm)
    SuchergButton: TBitBtn;
    SCANBUTTON: TBitBtn;
    scanSchliessen: TBitBtn;
    PanelXmailerStatus: TPanel;
    Image1: TImage;
    Status: TPanel;
    scanDriveBox: TDriveComboBox;
    nospam: TLabel;
    Labelsort: TLabel;
    Image7: TImage;
    Label1: TLabel;
    Ignore: TMemo;
    SortListBox: TListBox;
    Sortcheckbox: TCheckBox;
    scansubdir: TCheckBox;
    scanFileListBox: TFileListBox;
    scanDirectorylistBox: TDirectoryListBox;
    Lebenszeichen: TStatusBar;
    Labelsubdis: TLabel;
    LabelFilter: TLabel;
    EditFilter: TEdit;
    procedure SCANBUTTONClick(Sender: TObject);
    procedure SuchergButtonClick(Sender: TObject);
    procedure scansubdirClick(Sender: TObject);
    procedure SortcheckboxClick(Sender: TObject);
    procedure scanSchliessenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditFilterChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function TXT(TXTNr:integer):String;  {##Textstrings##}
  end;

var
  TXTs: TStringlist; {##extracted text vom Source##}
  ESCAN: TESCAN;
  GKeep,GTim:boolean; { Merker ob Mail Timer an war (abschalten) }

implementation

uses XMAIL61, Main,gnugettext;

{$R *.dfm}
 
{#### TEXT-STRINGS FROM SOURCE (c) 2004 by Bernd Dietzel  www.barret.de/textfromsource.zip ####} 
function TESCAN.TXT(TXTNr:integer):String;
begin
 if not Assigned(TXTs) then
 begin
  TXTs:=Tstringlist.create;
  with TXTs do begin
        {------- text list  -- Only Translate Intems with the {T}
{0}    {T}Add(form1.TXT(351)); // intern ##ABBRUCH##
{1}    {T}Add(_('E-Mail Adressen suchen'));
{2}       Add('*.;');
  end;
 end;
 Result := TXTs[TXTNr];
end;



procedure TESCAN.FormCreate(Sender: TObject);
begin
TranslateComponent (self);  {  gnugettext }
end;


{ *****in frheren Versionen hatte der Scanner kein separates Fenster
       daher alle Routinen in Form1 (Hauptfenster)  ******  }

procedure TESCAN.SCANBUTTONClick(Sender: TObject);

begin
 form1.scanbuttonclick(self); { Start }
end;

procedure TESCAN.SuchergButtonClick(Sender: TObject);
begin
 form1.suchergButtonclick(self); { gefundene Mailadressen in CC oder BCC vom Form1 }
end;

procedure TESCAN.scansubdirClick(Sender: TObject);
begin
 form1.scansubdirclick(self);   { Unterverzeichnisse durchsuchen }
end;

procedure TESCAN.SortcheckboxClick(Sender: TObject);
begin
 form1.SortcheckboxClick(self); { Ergebnisse sortieren }
end;

procedure TESCAN.scanSchliessenClick(Sender: TObject);
begin
  ESCAN.caption:=TXT(0) {##ABBRUCH##} ;      { wird abgefragt fr Unterbrechung des Scanvorgangs }
  EScan.Update;
//  lebenszeichen.visible:=false;  { Bunte Zeichen wrend des Scanvorgans aus }
//  scangroup.enabled:=true;
  scanbutton.enabled:=true;
//  nospam.visible:=true;          { kein Spam Bitte - Text }
  escan.close;
end;


procedure TESCAN.FormResize(Sender: TObject);
begin
// if escan.Width>770 then panelbild.Visible:=true else Panelbild.Visible:=false;
end;

procedure TESCAN.ToolButton1Click(Sender: TObject);
begin
{ Scan-Robot Bild aus }
//Form1.terminator3Click(self);
end;

procedure TimerMailaus;
{ Mail-Timer vorrbergehend abschalten }
begin
  GKeep:=getmailform.TimerKEEP.Enabled;
  GTim:=getmailform.TimerPOST.Enabled;
  getmailform.TimerKEEP.Enabled:=false;
  getmailform.TimerPost.Enabled:=false;
end;

procedure TimerMailan;
{ Mail-Timer wieder auf alte Werte }
begin
  getmailform.TimerKEEP.Enabled:=GKeep;
  getmailform.TimerPost.Enabled:=GTim;
end;

procedure TESCAN.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 TimerMailan; { Mail-Timer wieder auf alte Werte }
end;

procedure TESCAN.FormShow(Sender: TObject);
begin
 TimerMailaus; { Mail-Timer vorrbergehend abschalten }
 escan.caption:=TXT(1) {##E-Mail Adressen suchen##} ; { ggf vorhandener Text "ABBRUCH" lschen }
 escan.ShowHint:=form1.ShowHint;          { Hilfetexte }
end;

procedure TESCAN.EditFilterChange(Sender: TObject);
begin
 scanfilelistbox.Mask:=TXT(2) {##*.;##} +EditFilter.Text; { *.; = Directorys [.] [..] }
end;

end.
